<?php

/**
 * Description of SP
 *
 * @author ade
 */
class TransactionCalculator {

    public static function calcDetailBasePrice(&$sod, $taxInc) {
        $seratus = 100;

        if ($taxInc) {
            //Rumus -> NettPrice-SaleDTaxAmt+SaleD$discamt
            $TaxPcn = BHelp::EvalDiscExp(1, $sod->taxexp) * $seratus;
            $penyebut = $seratus + $TaxPcn;
            $hargaDisc = $sod->listprice - $sod->discamt;
            $sod->baseprice = ($sod->discamt + ($hargaDisc * ($seratus / $penyebut)));
        } else {
            $sod->baseprice = $sod->listprice;
        }
    }

    public static function calcDetailDisc(&$sod) {
        if ($sod->discexp != null && strlen($sod->discexp) > 0) {
            $sod->discamt = BHelp::EvalDiscExp($sod->listprice, $sod->discexp);
            $sod->totaldiscamt = $sod->discamt * $sod->qty;
        } else {
            $sod->totaldiscamt = 0;
            $sod->discamt = 0;
        }
    }

    public static function calcDetailSC(&$sod, $fisRate, $excRate) {
        $pembilang = $penyebut = $nettprice = $scableamt = $scamt = $SCPcn = 0;
        $itemid = $sod->itemid;
        $scid = null;
        $scexp = null;
        if ($sod->taxid != null) {
            $scid = Item::model()->getSCId($itemid);
            $scexp = Sc::model()->getSCExp($sod->scid);
            $SCPcn = BHelp::EvalDiscExp(1, $scexp) * 100;

            $pembilang = $SCPcn;
            $penyebut = 100;

            $nettprice = ($sod->listprice - $sod->discamt) * $sod->qty;
            $scableamt = $nettprice / $penyebut * 100 - $sod->totaldisc2amt;

            $penyebut = 100;
            $scamt = $scableamt * ($pembilang / $penyebut);

            $sod->totalscamt = $scamt;
            $sod->scamt = $scamt / $sod->qty;
        } else {
            $sod->totalscamt = 0;
            $sod->scamt = 0;
        }
    }

    public static function calcDetailTax(&$sod, $taxInc, $fisRate, $excRate) {
        $nettprice = $scableamt = $taxableamt = $taxamt = $TaxPcn = $pembilang = $penyebut = 0;

        $itemid = $sod->itemid;
        $taxid = null;
        $taxexp = null;

        if ($sod->taxid != null) {
            $taxid = Item::model()->getPurcTaxId($itemid);
            $taxexp = Tax::model()->getTaxExp($sod->taxid);
            $TaxPcn = BHelp::EvalDiscExp(1, $taxexp) * 100;

            $pembilang = $TaxPcn;
            if ($taxInc) {
                $penyebut = 100 + $TaxPcn;
            } else {
                $penyebut = 100;
            }

            $nettprice = ($sod->listprice - $sod->discamt) * $sod->qty;
            $scableamt = ($nettprice / $penyebut) * 100 - $sod->totaldisc2amt;
            $taxableamt = ($scableamt / $penyebut) * 100 + $sod->totalscamt;

            $penyebut = 100;
            $taxamt = $taxableamt * ($pembilang / $penyebut);


            $sod->totaltaxamt = $taxamt;
            $sod->basftotaltaxamt = $sod->totaltaxamt * $fisRate;
            $sod->basetotaltaxamt = $sod->totaltaxamt * $excRate;
            $sod->taxableamt = $taxableamt;
            $sod->taxamt = $taxamt / $sod->qty;
        } else {
            $sod->totaltaxamt = 0;
            $sod->basftotaltaxamt = 0;
            $sod->basetotaltaxamt = 0;
            $sod->taxableamt = 0;
            $sod->taxamt = 0;
        }
    }

    public static function calcDetailSubtotal(&$sod, $excRate) {
        $sod->subtotal = $sod->qty * ($sod->baseprice - $sod->discamt);
        $sod->basesubtotal = $sod->subtotal * $excRate;
    }

    public static function recalcMasterData(&$so) {
        $so->total = $so->subtotal - ($so->discamt + $so->taxamt);
        $so->basetotal = $so->basesubtotal - ($so->basediscamt + $so->basetaxamt);
    }

}

?>
